Linux下用Nginx作Perl程式伺服器及其中Perl模組的配置_nginx

來源:互聯網
上載者:User

perl + fastcgi + nginx搭建

nginx + fastcgi是php下最流行的一套環境了,那perl會不會也有fastcgi呢,當然有,今天來搭建下nginx下perl的fastcgi.效能方面也不亞於php,但是現在web程式php的流行程度perl無法比擬了,效能再好也枉然,但是部分小功能可以考慮使用perl的fastcgi來搞定.進入正題.
1. 準備軟體環境:

nginx:http://www.nginx.org
perl:系統內建
fastcgi:http://www.cpan.org/modules/by-module/FCGI/
1.1 nginx安裝
這裡就不再詳細介紹了~
1.2 perl安裝
一般linux都有內建perl,可以不用安裝,如果確實沒有,請執行:

# yum install perl

1.3 perl-fastcgi安裝

# cd /usr/local/src# wget http://www.cpan.org/modules/by-module/FCGI/FCGI-0.74.tar.gz# tar -xzvf FCGI-0.74.tar.gz# cd FCGI-0.74# perl Makefile.PL # make# make install

2. nginx虛擬機器主機配置

server {   listen  80;  server_name test.jb51.net;  #access_log /data/logs/nginx/test.jb51.net.access.log main;   index index.html index.php index.html;  root /data/site/test.jb51.net;   location /   {   }   location ~ \.pl$   {   include fastcgi_params;   fastcgi_pass 127.0.0.1:8999;   #fastcgi_pass unix:/var/run/jb51.net.perl.sock;   fastcgi_index index.pl;  }}

如果想把tcp/ip方式改為socket方式,可以修改fastcgi-wrapper.pl.

$socket = FCGI::OpenSocket( "127.0.0.1:8999", 10 ); #use IP sockets

改為

$socket = FCGI::OpenSocket( "/var/run/jb51.net.perl.sock", 10 ); #use IP sockets

3. 配置指令碼

3.1 fastcgi監聽指令碼
檔案路徑:/usr/bin/fastcgi-wrapper.pl

#!/usr/bin/perl use FCGI;use Socket;use POSIX qw(setsid); require 'syscall.ph'; &daemonize; #this keeps the program alive or something after exec'ing perl scriptsEND() { } BEGIN() { }*CORE::GLOBAL::exit = sub { die "fakeexit\nrc=".shift()."\n"; };eval q{exit};if ($@) { exit unless $@ =~ /^fakeexit/;}; &main; sub daemonize() { chdir '/'     or die "Can't chdir to /: $!"; defined(my $pid = fork) or die "Can't fork: $!"; exit if $pid; setsid     or die "Can't start a new session: $!"; umask 0;} sub main {  $socket = FCGI::OpenSocket( "127.0.0.1:8999", 10 ); #use IP sockets  $request = FCGI::Request( \*STDIN, \*STDOUT, \*STDERR, \%req_params, $socket );  if ($request) { request_loop()};   FCGI::CloseSocket( $socket );} sub request_loop {  while( $request->Accept() >= 0 ) {    #processing any STDIN input from WebServer (for CGI-POST actions)   $stdin_passthrough ='';   $req_len = 0 + $req_params{'CONTENT_LENGTH'};   if (($req_params{'REQUEST_METHOD'} eq 'POST') && ($req_len != 0) ){    my $bytes_read = 0;    while ($bytes_read < $req_len) {      my $data = '';      my $bytes = read(STDIN, $data, ($req_len - $bytes_read));      last if ($bytes == 0 || !defined($bytes));      $stdin_passthrough .= $data;      $bytes_read += $bytes;    }   }    #running the cgi app   if ( (-x $req_params{SCRIPT_FILENAME}) && #can I execute this?     (-s $req_params{SCRIPT_FILENAME}) && #Is this file empty?     (-r $req_params{SCRIPT_FILENAME})  #can I read this file?   ){  pipe(CHILD_RD, PARENT_WR);  my $pid = open(KID_TO_READ, "-|");  unless(defined($pid)) {   print("Content-type: text/plain\r\n\r\n");      print "Error: CGI app returned no output - ";      print "Executing $req_params{SCRIPT_FILENAME} failed !\n";   next;  }  if ($pid > 0) {   close(CHILD_RD);   print PARENT_WR $stdin_passthrough;   close(PARENT_WR);    while(my $s = <KID_TO_READ>) { print $s; }   close KID_TO_READ;   waitpid($pid, 0);  } else {     foreach $key ( keys %req_params){      $ENV{$key} = $req_params{$key};     }     # cd to the script's local directory     if ($req_params{SCRIPT_FILENAME} =~ /^(.*)\/[^\/]+$/) {       chdir $1;     }    close(PARENT_WR);   close(STDIN);   #fcntl(CHILD_RD, F_DUPFD, 0);   syscall(&SYS_dup2, fileno(CHILD_RD), 0);   #open(STDIN, "<&CHILD_RD");   exec($req_params{SCRIPT_FILENAME});   die("exec failed");  }   }   else {    print("Content-type: text/plain\r\n\r\n");    print "Error: No such CGI app - $req_params{SCRIPT_FILENAME} may not ";    print "exist or is not executable by this process.\n";   }   }}

3.2 fastcgi自啟動服務指令碼:

檔案路徑:/etc/rc.d/init.d/perl-fastcgi

檔案路徑:/etc/rc.d/init.d/perl-fastcgi
 

#!/bin/sh## nginx – this script starts and stops the nginx daemon## chkconfig: - 85 15# description: Nginx is an HTTP(S) server, HTTP(S) reverse \# proxy and IMAP/POP3 proxy server# processname: nginx# config: /opt/nginx/conf/nginx.conf# pidfile: /opt/nginx/logs/nginx.pid # Source function library.. /etc/rc.d/init.d/functions # Source networking configuration.. /etc/sysconfig/network # Check that networking is up.[ "$NETWORKING" = "no" ] && exit 0 perlfastcgi="/usr/bin/fastcgi-wrapper.pl"prog=$(basename perl) lockfile=/var/lock/subsys/perl-fastcgi start() { [ -x $perlfastcgi ] || exit 5 echo -n $"Starting $prog: " daemon $perlfastcgi retval=$? echo [ $retval -eq 0 ] && touch $lockfile return $retval} stop() { echo -n $"Stopping $prog: " killproc $prog -QUIT retval=$? echo [ $retval -eq 0 ] && rm -f $lockfile return $retval} restart() { stop start} reload() { echo -n $”Reloading $prog: ” killproc $nginx -HUP RETVAL=$? echo} force_reload() { restart}rh_status() { status $prog} rh_status_q() { rh_status >/dev/null 2>&1} case "$1" in start)  rh_status_q && exit 0  $1  ;; stop)  rh_status_q || exit 0  $1  ;; restart)  $1  ;; reload)  rh_status_q || exit 7  $1  ;; force-reload)  force_reload  ;; status)  rh_status  ;; condrestart|try-restart)  rh_status_q || exit 0  ;; *)  echo $"Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload}"  exit 2 esac

3.3 設定指令碼許可權

# chmod a+x /usr/bin/fastcgi-wrapper.pl# chmod a+x /etc/rc.d/init.d/perl-fastcgi


4. FastCGI測試
4.1 啟動nginx與fastcgi

# /usr/local/nginx-1.4.2/sbin/nginx# /etc/init.d/perl-fastcgi start

4.2 perl測試檔案:
檔案路徑/data/site/test.jb51.net/test.pl

#!/usr/bin/perl print "Content-type:text/html\n\n";print <<EndOfHTML;<html><head><title>Perl Environment Variables</title></head><body><h1>Perl Environment Variables</h1>EndOfHTML foreach $key (sort(keys %ENV)) { print "$key = $ENV{$key}<br>\n";} print "</body></html>";

5. 訪問測試

5.1 訪問
http://http:test.jb51.net/test.pl,出現內容表示OK.
 
6. 簡單壓力測試:
6.1 使用tcp/ip方式

ab -n 1000 -c 10 http://test.jb51.net/test.pl

他是在是太慢了,只好用10個並發,共計100個請求來測試.

6.2 使用socket方式:

ab -n 100000 -c 500 http://test.jb51.net/test.pl

很奇怪,使用tcp/ip方式,每秒就140多個請求,而使用socket方式卻有5800個請求/秒。差距不是一般的大。順便測試了一下php的fastcgi,大概請求在3000(tcp/ip方式),4800(socket方式)。

perl模組的使用
如果對於一個絕大部分內容是靜態網站,只有極少數的地方需要動態顯示,碰巧你又瞭解一點perl知識,那麼nginx + perl的結合就能很好解決問題。要想nginx支援perl指令碼,在編譯nginx時候需要如下參數:

./configure --with-http_perl_module

如果make時候出現如下類似錯誤:

Can't locate ExtUtils/Embed.pm in @INC (@INC contains: /usr/lib/perl5/5.10.0/i386-linux-thread-multi /usr/lib/perl5/5.10.0 /usr/local/lib/perl5/site_perl/5.10.0/i386-linux-thread-multi /usr/local/lib/perl5/site_perl/5.10.0 /usr/lib/perl5/vendor_perl/5.10.0/i386-linux-thread-multi /usr/lib/perl5/vendor_perl/5.10.0 /usr/lib/perl5/vendor_perl /usr/local/lib/perl5/site_perl .)

你的機器上可能需要安裝perl-devel perl-ExtUtils-Embed,對於centos系統,直接使用yum搞定,例如:

yum -y install perl-devel perl-ExtUtils-Embed

nginx中使用perl有兩種方法,一種是直接在設定檔寫,還有一種是把perl指令碼寫在外部檔案中,下面主要介紹一下第二種用法。
假設nginx的根目錄為/usr/local/nginx,perl指令碼存放的目錄為nginx的根目錄下的perl/lib下,指令碼名字為test.pm,nginx配置為:

#位於http配置中 perl_modules perl/lib; perl_require test.pm; #位於server配置中 location /user/ { perl pkg_name::process; }

上述配置是把所有來自http://servername/user/下的請求交由test.pm指令碼中定義的process方法來處理。
test.pm指令碼的內容如下:

package pkg_name; use Time::Local;use nginx; sub process { my $r = shift;  $r->send_http_header('text/html; charset=utf-8'); my @arr = split('/', $r->uri); my $username = @arr[2];  if (!$username || ($username eq "")) { $username = "Anonymous"; }  $r->print('Hello, You name is : <strong>' . $username . '</strong>'); $r->rflush(); return;} 1;__END__

當你訪問http://servername/user/netingcn,你應該可以在網頁上看到:

Hello, You name is : netingcn

另外:當使用 use nginx 時,會有如下的對象可以調用,可以看到上面 shift 一個對象到 $r 上,然後就可以用 $r 調用那些對象了:

  • $r->args – 請求的參數 .
  • $r->discard_request_body – 這個參數是讓 Nginx 放棄 request 的 body 的內容.
  • $r->filename – 返回合適的請求檔案的名字
  • $r->has_request_body(function) – 如果沒有請求主體,返回0,但是如果請求主體存在,那麼建立傳遞的函數並返回1,在程式的最後,nginx將調用指定的處理器.
  • $r->header_in(header) – 尋找要求標頭的資訊
  • $r->header_only – 如果我們只要返回一個響應的頭
  • $r->header_out(header, value) – 設定響應的頭
  • $r->internal_redirect(uri) – 使內部重新導向到指定的URI,重新導向僅在完成perl指令碼後發生.可以使用 header_out(Location….的方法來讓瀏覽器自己重新導向
  • $r->print(args, …) – 發送資料給用戶端
  • $r->request_body – 得到用戶端提交過來的內容 (body 的參數,可能需要修改 nginx 的 client_body_buffer_size. )
  • $r->request_body_file —給客戶的 body 存成檔案,並返迴文件名
  • $r->request_method — 得到請求 HTTP method.
  • $r->remote_addr – 得到用戶端的 IP 位址.
  • $r->rflush – 立即傳送資料給用戶端
  • $r->sendfile(file [, displacement [, length ] ) – 傳送給用戶端指定檔案的內容,可選的參數表明只傳送資料的位移量與長度,精確的傳遞僅在perl指令碼執行完畢後生效.這可是所謂的進階功能啊
  • $r->send_http_header(type) – 添加一個回應的 http 頭的資訊
  • $r->sleep(milliseconds, handler) – 設定為請求在指定的時間使用指定的處理方法和停止處理,在此期間nginx將繼續處理其他的請求,超過指定的時間後,nginx將運行安裝的處理方法,注意你需要為處理方法通過一個reference,在處理器間轉寄資料你可以使用$r->variable().
  • $r->status(code) – 設定 http 的響應碼
  • $r->unescape(text) – 使用 http 方法加密內容如 %XX
  • $r->uri – 得到請求的 URL.
  • $r->variable(name[, value]) – 設定變數的值

相關文章

聯繫我們

該頁面正文內容均來源於網絡整理,並不代表阿里雲官方的觀點,該頁面所提到的產品和服務也與阿里云無關,如果該頁面內容對您造成了困擾,歡迎寫郵件給我們,收到郵件我們將在5個工作日內處理。

如果您發現本社區中有涉嫌抄襲的內容,歡迎發送郵件至: info-contact@alibabacloud.com 進行舉報並提供相關證據,工作人員會在 5 個工作天內聯絡您,一經查實,本站將立刻刪除涉嫌侵權內容。

A Free Trial That Lets You Build Big!

Start building with 50+ products and up to 12 months usage for Elastic Compute Service

  • Sales Support

    1 on 1 presale consultation

  • After-Sales Support

    24/7 Technical Support 6 Free Tickets per Quarter Faster Response

  • Alibaba Cloud offers highly flexible support services tailored to meet your exact needs.